void ReadEncoderPos()
{  
  byte EncoderPosition2;
  
  int result = 0;
  
  EncoderPosition2 = (digitalRead(EncPinB) << 1) + digitalRead(EncPinA);

  if (EncoderPosition2 != EncoderPosition)
  {
    boolean isBwd = ((EncoderPosition == 0) && (EncoderPosition2 == 1)) ||
                    ((EncoderPosition == 1) && (EncoderPosition2 == 3)) ||
                    ((EncoderPosition == 3) && (EncoderPosition2 == 2)) ||
                    ((EncoderPosition == 2) && (EncoderPosition2 == 0));

    boolean isFwd = ((EncoderPosition == 0) && (EncoderPosition2 == 2)) ||
                    ((EncoderPosition == 1) && (EncoderPosition2 == 0)) ||
                    ((EncoderPosition == 3) && (EncoderPosition2 == 1)) ||
                    ((EncoderPosition == 2) && (EncoderPosition2 == 3));                 

    if (isFwd) 
    {
      EncodercCount += 1;
      //Serial.println("Forward");
    }
    if (isBwd) 
    {
      EncodercCount -= 1;
      //Serial.println("Backward");
    }                

    if ((EncoderFirstPos == EncoderPosition2) && (abs(EncodercCount) >= 4))
    {
      EncodercCount = 0;

      if (isFwd) 
      {
        result = 1;
      }
      if (isBwd) 
      {
        result = -1;
      }
    }

    EncoderPosition = EncoderPosition2;
  }

  if (EncoderDiff == 0) // Else it means that the previous value wasn't used and reset by anyone
  {
    EncoderDiff = result;
  }
}
