void main_menu()
{
  char line[22];
  
  boolean inverted = false;
  unsigned long lastinvert = millis();
  lastmove = lastinvert;
  boolean encpressed = true;
  boolean do_not_exit_main_menu = true;
  
  tft.clear();
  
  if (LCD_jour == 1)
  {
    fgcolor=ST7735_WHITE;
  }
  else
  {
    fgcolor=ST7735_RED;
  }  
  
  tft.drawstring_P(32,0,PSTR("*Demarrage*"),fgcolor);
  tft.drawstring_P(07,8,PSTR("Mode  :"),fgcolor);
  tft.drawchar(116,8,DRPCHAR,fgcolor);
  tft.drawstring_P(07,16,PSTR("Delai :"),fgcolor);
    tft.drawstring_P(78,16,PSTR("secondes"),fgcolor);
  tft.drawstring_P(07,24,PSTR("Duree :"),fgcolor);
  if (EC_mode != 1)
  {
    tft.drawstring_P(07,40,PSTR("Pause :"),fgcolor);
    tft.drawstring_P(07,48,PSTR("Nombre :"),fgcolor);
      tft.drawstring_P(91,48,PSTR("photos"),fgcolor);
  }
  tft.drawstring_P(50,56,PSTR("- Test -"),fgcolor);
  tft.drawstring_P(07,64,PSTR("Veille LCD"),fgcolor);
    sprintf(line,"%02d:%02d",LCD_veille_minute,LCD_veille_seconde);
    tft.drawstring(72,64,line,fgcolor);  
  tft.drawstring_P(07,72,PSTR("Mode  jour  nuit"),fgcolor);
  if (LCD_jour == 1)
  {
    tft.drawchar(37,72,CHKCHAR,fgcolor);
    tft.fillRect(73,72,5,8,ST7735_BLACK);            
  }
  else
  {
    tft.fillRect(37,72,5,8,ST7735_BLACK);            
    tft.drawchar(73,72,CHKCHAR,fgcolor);
  }   
  tft.drawstring_P(07,80,PSTR("Luminosite LCD"),fgcolor);
    sprintf(line,"%03d",LCD_lumi);
    tft.drawstring(96,80,line,fgcolor);
  tft.drawstring_P(07,88,PSTR("Pre-Focus"),fgcolor);
    sprintf(line,"%03d",SLR_prefocus);
    tft.drawstring(67,88,line,fgcolor);
    tft.drawstring_P(89,88,PSTR("sec."),fgcolor);
  tft.drawstring_P(07,96,PSTR("Pause mini"),fgcolor);
    sprintf(line,"%04d",SLR_pause_mini_milliseconde);
    tft.drawstring(73,96,line,fgcolor);
    tft.drawstring_P(102,96,PSTR("ms"),fgcolor);
  tft.drawstring_P(07,104,PSTR("Verr. mirroir"),fgcolor);
  tft.drawstring_P(07,112,PSTR("Sauvegarder param"),fgcolor);
  tft.drawstring_P(07,120,PSTR("Recharger param"),fgcolor);
      
  switch (EC_mode) 
  {
    case 0:
      tft.drawstring_P(54,8,PSTR("Astro"),fgcolor);
      break;
    case 1:
      //unique
      tft.drawstring_P(54,8,PSTR("Unique"),fgcolor);
      break;
    case 2:
      //Increment
      tft.drawstring_P(54,8,PSTR("Increment"),fgcolor);
      tft.drawstring_P(07,32,PSTR("Incr. :"),fgcolor);
      sprintf(line,"%02d:%02d:%02d.%03d",EC_increment_heure,EC_increment_minute,EC_increment_seconde,EC_increment_milliseconde);
      tft.drawstring(54,32,line,fgcolor);
      break;
    default:
      break;
  }
  
  if (SLR_verr_mirroir == 1)
  {
    tft.drawchar(12,0,LCKCHAR,fgcolor);
    tft.drawchar(90,104,LCKCHAR,fgcolor);
  }
  
  if ((SLR_prefocus > EC_delais) and (SLR_verr_mirroir == 1))
  {
    sprintf(line,"%03d",SLR_prefocus);
    tft.drawchar(43,16,LCKCHAR,fgcolor);
  }
  else
  {
    sprintf(line,"%03d",EC_delais);
  }  
  tft.drawstring(54,16,line,fgcolor);
  
  sprintf(line,"%02d:%02d:%02d.%03d",EC_duree_heure,EC_duree_minute,EC_duree_seconde,EC_duree_milliseconde);
  tft.drawstring(54,24,line,fgcolor);

  if (EC_mode != 1)
  {
    if ((SLR_prefocus > hmsms2ms(EC_intervalle_heure, EC_intervalle_minute, EC_intervalle_seconde, EC_intervalle_milliseconde)) and (SLR_verr_mirroir == 1))
    {
      sprintf(line,"%02d:%02d:%02d.%03d",0,0,SLR_prefocus,0);
      tft.drawchar(42,40,LCKCHAR,fgcolor);
    }
    else
    {
      sprintf(line,"%02d:%02d:%02d.%03d",EC_intervalle_heure,EC_intervalle_minute,EC_intervalle_seconde,EC_intervalle_milliseconde);
    } 
    tft.drawstring(54,40,line,fgcolor);

    sprintf(line,"%04d",EC_nombre);
    tft.drawstring(60,48,line,fgcolor);
  }
  
  drawfleche(mainmenupos,0,0,120);

  while (do_not_exit_main_menu)
  {
    encpressed = ((digitalRead(EncPress) == LOW) &&
                  (! encpressed) && 
                  ((millis() - lastpress)>DeBounce));
                  
    checkveille();

    if (encpressed)
    {
      while (digitalRead(EncPress) == LOW)
      {
      }
      lastpress = millis();
      lastmove = lastpress;
      
      checkveille();

      switch (mainmenupos) 
      {
        case 0:
          // Demarrage
          do_not_exit_main_menu = submenu_PDV();
          break;
        case 1:
          // Mode
          do_not_exit_main_menu = submenu_Mode(EC_mode);
          break;
        case 2:
          // Delai
          EC_delais = modifyvlalue(EC_delais,50,16,3,0,999,1);

          do_not_exit_main_menu = false;
          break;
        case 3:
          // Duree
          EC_duree_heure        = modifyvlalue(EC_duree_heure,50,24,2,0,99,1);
          EC_duree_minute       = modifyvlalue(EC_duree_minute,68,24,2,0,59,1);
          EC_duree_seconde      = modifyvlalue(EC_duree_seconde,86,24,2,0,59,1);
          EC_duree_milliseconde = modifyvlalue(EC_duree_milliseconde,104,24,3,0,999,100);
  
          do_not_exit_main_menu = false;
          break;
        case 4:
          // Increment
          if (EC_mode == 2) // Increment
          {
            EC_increment_heure        = modifyvlalue(EC_increment_heure,50,32,2,0,99,1);
            EC_increment_minute       = modifyvlalue(EC_increment_minute,68,32,2,0,59,1);
            EC_increment_seconde      = modifyvlalue(EC_increment_seconde,86,32,2,0,59,1);
            EC_increment_milliseconde = modifyvlalue(EC_increment_milliseconde,104,32,3,0,999,100);
          }
  
          do_not_exit_main_menu = false;
          break;
        case 5:
          // intervalle
          if (EC_mode != 1) // pas Unique
          {
            EC_intervalle_heure        = modifyvlalue(EC_intervalle_heure,50,40,2,0,99,1);
            EC_intervalle_minute       = modifyvlalue(EC_intervalle_minute,68,40,2,0,59,1);
            EC_intervalle_seconde      = modifyvlalue(EC_intervalle_seconde,86,40,2,0,59,1);
            EC_intervalle_milliseconde = modifyvlalue(EC_intervalle_milliseconde,104,40,3,0,999,100);
          }          
  
          do_not_exit_main_menu = false;
          break;
        case 6:
          // Nombre
          if (EC_mode != 1) // pas Unique
          {
            EC_nombre = modifyvlalue(EC_nombre,56,48,4,1,9999,1);
          }

          do_not_exit_main_menu = false;
          break;
        case 7:
          // Configuration
          //do_not_exit_main_menu = true;
          submenu_Test();
          do_not_exit_main_menu = false;
          break;
        case 8:
          // Veille LCD - 58,40 -> 72,64
          LCD_veille_minute  = modifyvlalue(LCD_veille_minute , 68, 64, 2, 0, 99, 1);
          LCD_veille_seconde = modifyvlalue(LCD_veille_seconde, 86, 64, 2, 0, 59, 1);
          
          do_not_exit_main_menu = false;
          break;
        case 9:
          // Mode jour/nuit
          if (LCD_jour == 1)
          {
            LCD_jour = 0;
          }
          else
          {
            LCD_jour = 1;
          }          
          do_not_exit_main_menu = false;
          break;
        case 10:
          // Luminosité
          LCD_lumi  = modifyvlalue(LCD_lumi , 92, 80, 3, 0, 254, 8);
          analogWrite(BacklightPWM,LCD_lumi);
          do_not_exit_main_menu = false;
          break;
        case 11:
          // Pre-Focus
          SLR_prefocus = modifyvlalue(SLR_prefocus, 63, 88, 3, 0, 255, 1);
          if ((SLR_verr_mirroir == 1) and (SLR_prefocus < 2))
          {
            SLR_prefocus = 2;
          }                    
          do_not_exit_main_menu = false;
          break;
        case 12:
          // Pause mini
          SLR_pause_mini_milliseconde = modifyvlalue(SLR_pause_mini_milliseconde, 69, 96, 4, 0, 1000, 50);
          do_not_exit_main_menu = false;
          break;
        case 13:
          // Verrouillage mirroir
          if (SLR_verr_mirroir == 0)
          {
            SLR_verr_mirroir = 1;
            if (SLR_prefocus < 2)
            {
              SLR_prefocus = 2;
            }
          }
          else
          {
            SLR_verr_mirroir = 0;
          }           
          do_not_exit_main_menu = false;
          break;
        case 14:
          // Sauvegarder Param
          Write_EEPROM();
          tft.drawstring_P(115,112,PSTR("OK"),fgcolor);
          do_not_exit_main_menu = true;
          break;
        case 15:
          // Recharger Param
          Read_EEPROM();
          do_not_exit_main_menu = false;
          break;
        default:
          do_not_exit_main_menu = false;  
          // if nothing else matches, do the default
          // default is optional
      }      
    }
    else
    if (EncoderDiff != 0)
    {
      lastmove = millis();
      
      checkveille();
      
      if ((EncoderDiff == 1) && (mainmenupos < 15))
      {
        mainmenupos++;
      }
      if ((EncoderDiff == -1) && (mainmenupos > 0))
      {
        mainmenupos--;
      }      
      
      drawfleche(mainmenupos,0,0,120);
      
      EncoderDiff = 0;
    }
    
    if ((millis()-lastinvert) > 300)
    {
      inverted = !inverted;
      
      if (inverted)
      {
        tft.drawchar(153,0,HRTCHAR,ST7735_RED);
      }
      else
      {
        tft.fillRect(153,0,5,8,ST7735_BLACK);
      }
      
      lastinvert = millis();
    }      
  }
}
