boolean submenu_PDV()
{
  char line[5];

  tft.fillRect(0,0,159,8,ST7735_BLACK);
  tft.fillRect(0,64,159,64,ST7735_BLACK);
  tft.fillRect(0,8,6,64,ST7735_BLACK);
  
  tft.drawstring_P(7,0,PSTR("Photo 0001 sur"),fgcolor,1,true);
  if (EC_mode==2)
  {
    sprintf(line,"%04d",EC_nombre);
  }
  else
  {
    sprintf(line,"%04d",1);
  }
  tft.drawstring(96,0,line,fgcolor,1,true);
  
  tft.fillRect(6,48,121,16,ST7735_BLACK);
  tft.drawstring_P(7,56,PSTR("Reste :"),fgcolor,1,true);

  if (SLR_verr_mirroir == 1)
  {
    tft.drawchar(115,8,LCKCHAR,fgcolor);
  }

  pdv_increment();
  
  return false;
}

void pdv_increment()
{
  char line[5];
  
  int i, j;
  
  unsigned long ms;
  
  int DN_nombre = 1;
  unsigned long EC_duree;
  unsigned long EC_increment;
  unsigned long EC_intervalle;

  unsigned long DN_delais;
  unsigned long DN_duree;
  unsigned long DN_intervalle;  
  unsigned long DN_increment;
  unsigned long DN_restant;
  
  unsigned long DN_total = 0;

  unsigned long RL_intervalle;  
  
  byte DN_heure;
  byte DN_minute;
  byte DN_seconde;
  int  DN_milliseconde;  
  
  boolean Verrouillage = false;
  
  j = -1;
  
  tft.drawchar(0,16,ARRCHAR,fgcolor);
  tft.drawchar(0,24,DOTCHAR,fgcolor);
  tft.drawchar(0,40,DOTCHAR,fgcolor);

  EC_duree      = hmsms2ms(EC_duree_heure, EC_duree_minute, EC_duree_seconde, EC_duree_milliseconde);
  EC_increment  = hmsms2ms(EC_increment_heure, EC_increment_minute, EC_increment_seconde, EC_increment_milliseconde);
  EC_intervalle = hmsms2ms(EC_intervalle_heure, EC_intervalle_minute, EC_intervalle_seconde, EC_intervalle_milliseconde);
  
  if (EC_intervalle == 0)
  {
    EC_intervalle = SLR_pause_mini_milliseconde;
  }
  
  if ((EC_intervalle < (unsigned long)SLR_prefocus*1000) and (SLR_verr_mirroir == 1))
  {
    EC_intervalle = (unsigned long)SLR_prefocus*1000;
    tft.drawchar(42,40,LCKCHAR,fgcolor);
  }
  else
  {
    tft.drawchar(42,40,':',fgcolor);
  }
  
  if (EC_mode != 1)
  {
    DisplayMs(EC_intervalle,54, 40, fgcolor);
  }
  else
  {
    tft.fillRect(0,40,127,8,ST7735_BLACK);
  }
  
  DN_increment = 0;
  if (EC_mode == 2)
  {
    for (i=1;i<EC_nombre;i++) // total increment restant
    {
      DN_increment += (i*EC_increment);
    }  
    DisplayMs(DN_increment, 54, 32, fgcolor);
    
  }

  if ((SLR_prefocus > EC_delais) and (SLR_verr_mirroir == 1))
  {
    DN_delais = SLR_prefocus;
  }
  else
  {
    DN_delais = EC_delais;
  }
  
  if (SLR_verr_mirroir == 1)
  {
    analogWrite(EncGRN,16);
    digitalWrite(SLR_FOCUS,HIGH);   
    digitalWrite(EncRED,HIGH);
    digitalWrite(SLR_SHOT,HIGH);
    delay(500);
    digitalWrite(EncRED,LOW);
    digitalWrite(SLR_SHOT,LOW);        
    digitalWrite(EncGRN,LOW);
    digitalWrite(SLR_FOCUS,LOW);        
  }     
  
  DN_delais = (DN_delais*1000) + millis();  
  
  while (millis() < DN_delais)
  {
    i = (DN_delais-millis())/1000;
    
    if (i < SLR_prefocus) // focus 1s avant déclenchement
    {
      analogWrite(EncGRN,16);
      digitalWrite(SLR_FOCUS,HIGH);   
    }       
    
    if (i != j)
    {
      sprintf(line,"%03d",i);
      tft.drawstring(54,16,line,fgcolor,1,false);

      DN_restant = (EC_nombre-(DN_nombre-1)) * RL_intervalle;
      DN_restant += ((EC_nombre-DN_nombre) * EC_duree);
      DN_restant += (DN_delais-millis());
      DN_restant += DN_increment; 
      DisplayMs(DN_restant,54, 56, fgcolor, false);
      
      if (DN_total == 0)
      {
        DN_total = DN_restant;
      }  
      
//      drawprogressbar(DN_total-DN_restant,DN_total,6,48,125,55,true);
      
      j = i;
    }  
    
    delay(100);
    if (EncoderDiff != 0)
    {
      lastmove = millis();
      EncoderDiff = 0;
    }
    if (digitalRead(EncPress) == LOW)
    {
      lastmove = millis();
      checkveille();
      while (digitalRead(EncPress) == LOW)
      {
      }
      digitalWrite(EncRED,LOW);      
      digitalWrite(EncGRN,LOW);      
      return;
    }
    checkveille();
  }
  
  while (DN_nombre <= EC_nombre)
  {
    tft.drawchar(0,16,DOTCHAR,fgcolor,1,false);
    tft.drawchar(0,24,ARRCHAR,fgcolor,1,false);
    if (EC_mode != 1) { tft.drawchar(0,40,DOTCHAR,fgcolor,1,false); }

    sprintf(line,"%04d",DN_nombre);
    tft.drawstring(43,0,line,fgcolor,1,false);
    
    DN_duree = EC_duree + millis();
    
    if (EC_mode == 2)
    {
      DN_increment = 0;
      for (i=1;i<DN_nombre;i++) // increment actuel
      {
        DN_increment += EC_increment;
      }
      DN_duree += DN_increment;

      DisplayMs(DN_increment,54, 32, fgcolor, false);

      DN_increment = 0;
      for (i=DN_nombre+1;i<EC_nombre;i++) // total increment restant
      {
        DN_increment += (i*EC_increment);
      }    
    }
    
    analogWrite(EncGRN,16);
    digitalWrite(SLR_FOCUS,HIGH);
    
    digitalWrite(EncRED,HIGH);
    digitalWrite(SLR_SHOT,HIGH);
   
    while (millis() < DN_duree)
    {
      ms = DN_duree-millis();

      DisplayMs(ms,54, 24, fgcolor, false);
  
      DN_restant = (EC_nombre-(DN_nombre-1)) * RL_intervalle;
      DN_restant += ((EC_nombre-DN_nombre) * EC_duree);
      DN_restant += ms;
      if (EC_mode == 2) { DN_restant += DN_increment; }
    
      DisplayMs(DN_restant, 54, 56, fgcolor, false);
      
      delay(100);
      if (EncoderDiff != 0)
      {
        lastmove = millis();
        EncoderDiff = 0;
      }
      if (digitalRead(EncPress) == LOW)
      {
        lastmove = millis();
        checkveille();
        while (digitalRead(EncPress) == LOW)
        {
        }
        digitalWrite(EncRED,LOW);      
        digitalWrite(EncGRN,LOW);      
        return;
      }
      checkveille();     
    }
    
    digitalWrite(EncRED,LOW);
    digitalWrite(SLR_SHOT,LOW);
    digitalWrite(EncGRN,LOW);
    digitalWrite(SLR_FOCUS,LOW);    

    DN_increment = 0;
    for (i=1;i<=DN_nombre;i++) // prochain increment
    {
      DN_increment += EC_increment;
    }
    DN_duree = EC_duree + DN_increment;

    DisplayMs(DN_duree, 54, 24, fgcolor, false);
    
    tft.drawchar(0,16,DOTCHAR,fgcolor,1,false);
    tft.drawchar(0,24,DOTCHAR,fgcolor,1,false);
    tft.drawchar(0,40,ARRCHAR,fgcolor,1,false);
    
    DN_increment = 0;
    for (i=DN_nombre+1;i<EC_nombre;i++) // total increment restant
    {
      DN_increment += (i*EC_increment);
    }

    Verrouillage = false;;
  
    DN_intervalle = EC_intervalle + millis();
    
    if (EC_mode == 1)
    {
      DN_nombre = EC_nombre;
    }
    
    if (DN_nombre < EC_nombre) // si dernière boucle on ne fait plus de pause
    {
      while (millis() < DN_intervalle)
      {
        ms = DN_intervalle-millis();
        i = ms/1000;
        
        if (i < SLR_prefocus) // focus 1s avant déclenchement
        {
          if ((EC_intervalle-ms) > SLR_pause_mini_milliseconde)
          {
            analogWrite(EncGRN,16);
            digitalWrite(SLR_FOCUS,HIGH);
          }
          if ((SLR_verr_mirroir == 1) and (Verrouillage == false) and (ms < (SLR_prefocus-1)*1000))
          {
            Verrouillage = true;
            analogWrite(EncGRN,16);
            digitalWrite(SLR_FOCUS,HIGH);
            digitalWrite(EncRED,HIGH);
            digitalWrite(SLR_SHOT,HIGH);
            delay(100);
            digitalWrite(EncRED,LOW);
            digitalWrite(SLR_SHOT,LOW);        
            digitalWrite(EncGRN,LOW);
            digitalWrite(SLR_FOCUS,LOW);        
          }      
        }         
        
        if ((i < 1) & (EC_intervalle > 30000))// focus 1s avant déclenchement si delais > 30s
        {
          analogWrite(EncGRN,16);
          digitalWrite(SLR_FOCUS,HIGH);
        }        
        
        if (EC_mode != 1)
        {
          DisplayMs(ms, 54, 40, fgcolor, false);
        }
  
        DN_restant  = ((EC_nombre-DN_nombre) * RL_intervalle);
        DN_restant += ((EC_nombre-DN_nombre) * EC_duree);
        DN_restant += ms;
        DN_restant += DN_increment;

        DisplayMs(DN_restant, 54, 56, fgcolor, false);
        
        delay(100);
        if (EncoderDiff != 0)
        {
          lastmove = millis();
          EncoderDiff = 0;
        }
        if (digitalRead(EncPress) == LOW)
        {
          lastmove = millis();
          checkveille();
          while (digitalRead(EncPress) == LOW)
          {
          }
          digitalWrite(EncRED,LOW);      
          digitalWrite(EncGRN,LOW);      
          return;
        }
        checkveille();      
      }    
      
      if (EC_mode != 1)
      {
        DisplayMs(EC_intervalle, 54, 40, fgcolor, false);        
      }  
      DN_nombre += 1;
    }
    else
    {
       DN_nombre += 1;
    }
  }
  
  DN_increment = 0;
  for (i=1;i<EC_nombre;i++) // dernier increment
  {
    DN_increment += EC_increment;
  }
  DN_duree = EC_duree + DN_increment;

  DisplayMs(DN_duree, 54, 24, fgcolor, false);

  tft.fillRect(6,56,121,8,ST7735_BLACK);
  tft.drawstring_P(54,56,PSTR("Fini"),fgcolor);
  tft.fillRect(0,8,6,56,ST7735_BLACK);

  tft.drawchar(0,56,ARRCHAR,fgcolor,1,false);

  waitatend();
}
